/* Copyright (c) 2015, 2022, Oracle and/or its affiliates.
   Copyright (c) 2024, GreatDB Software Co., Ltd.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License, version 2.0,
   as published by the Free Software Foundation.

   This program is also distributed with certain software (including
   but not limited to OpenSSL) that is licensed under separate terms,
   as designated in a particular file or component or in included license
   documentation.  The authors of MySQL hereby grant you an additional
   permission to link the program and your derivative works with the
   separately licensed software that they have included with MySQL.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License, version 2.0, for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301  USA */

SET @old_sql_log_bin = @@session.sql_log_bin;
SET SQL_LOG_BIN = OFF;

CREATE DATABASE IF NOT EXISTS sys_audit;

CREATE TABLE IF NOT EXISTS sys_audit.audit_log (
  name VARCHAR(64) NOT NULL,
  record VARCHAR(64) NOT NULL,
  timestamp VARCHAR(64) NOT NULL,
  command_class VARCHAR(64) NOT NULL,
  connection_id BIGINT NOT NULL,
  status VARCHAR(64) NOT NULL,
  sqltext MEDIUMTEXT NOT NULL,
  user VARCHAR(64) NOT NULL,
  host VARCHAR(64) NOT NULL,
  priv_user VARCHAR(64) NOT NULL,
  os_user VARCHAR(64) NOT NULL,
  ip VARCHAR(64) NOT NULL,
  db VARCHAR(64) NOT NULL,
  server_version VARCHAR(64),
  os_version VARCHAR(64) NOT NULL,
  server_id BIGINT NOT NULL,
  timegmt BIGINT UNSIGNED NOT NULL,
  PRIMARY KEY record(record)
)CHARACTER SET utf8mb4 COLLATE utf8mb4_bin ENGINE=INNODB;

INSTALL PLUGIN audit_log SONAME 'audit_log.so';
CREATE FUNCTION audit_login_messages RETURNS STRING SONAME 'audit_login_messages.so';

SET SQL_LOG_BIN = @old_sql_log_bin;
